SystemOrganization addCategory: #'JQWidgetBox-TimePickr-Dev-Examples'!
SystemOrganization addCategory: #'JQWidgetBox-TimePickr-Dev-Tests'!

JQWidgetExample subclass: #JQTimepickrExample
	instanceVariableNames: 'time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-TimePickr-Dev-Examples'!

!JQTimepickrExample classSide methodsFor: 'as yet unclassified' stamp: 'jmck 8/8/2010 18:19'!
description
	^'JQuery TimePicker'! !

!JQTimepickrExample classSide methodsFor: 'as yet unclassified' stamp: 'jmck 8/8/2010 18:19'!
shortName
	^'timepicker'! !

!JQTimepickrExample methodsFor: 'initialization' stamp: 'jmck 8/8/2010 18:48'!
initialize
	| t |
	super initialize.
	t := Time now.
	time := Time hour: t hour minute: t minutes second: 0! !

!JQTimepickrExample methodsFor: 'rendering' stamp: 'JohnMcKeon 8/30/2010 17:07'!
renderContentOn: html
	self renderIntroOn: html.
	html horizontalRule.
	self renderTimepickrOn: html.
	html horizontalRule.
	self renderHandledOn: html.
	html horizontalRule.
	html div
		id: #timevalue;
		with: [ self renderTimeOn: html ]! !

!JQTimepickrExample methodsFor: 'rendering' stamp: 'JohnMcKeon 8/30/2010 17:14'!
renderHandledOn: html
	html paragraph: 'This is a "handled" time picker. By setting the handle option the user must click the clock to bring up the time picker'.
	html div: [
		html textInput
			on: #time of: self;
			script: (html jQuery new timepickr
				trigger: 'nothing';
				handle: '$("#clock")';
				rangeEvery15Min;
				select: ((html jQuery ajax serializeThis), 
					((html jQuery id: #timevalue) load html: [ :r | self renderTimeOn: r ]) ));
			with: time asString.
	html image
		style: 'overflow: hideden';
		id: #clock;
		url: self library / #clockPng. ].
! !

!JQTimepickrExample methodsFor: 'rendering' stamp: 'JohnMcKeon 8/30/2010 17:14'!
renderIntroOn: html
	html heading level: 2; with: 'JQuery Timepickr Example'.
	html paragraph: 'The Timpickr widget by Jason Huck uses a unique style of rendering selector buttons so the user need click only once to select the desired time. The current inplementation is a modified version by Danny Wachsstock. It is smaller and does not use any external javascript libraries'.
	html paragraph: [
		html text: 'See the full documentation at: '.
		html anchor url: self url; with: self url ]! !

!JQTimepickrExample methodsFor: 'rendering' stamp: 'JohnMcKeon 8/29/2010 13:37'!
renderTimeOn: html
	html label: 'Current value of time: ', time greaseString! !

!JQTimepickrExample methodsFor: 'rendering' stamp: 'JohnMcKeon 8/30/2010 17:40'!
renderTimepickrOn: html
	html paragraph: 'This a normal time picker. It has the animSpeed set to slow which gives the "slide-in" effect of the minutes selector buttons and am/pm buttons. ResetOnBlur is set to true which should set the input field back to its original value. Minutes is given in 5 minute increments and can be set to any set of minute values you like. Also the select callback is set to update the text below with the selected time.'.
	html textInput
		on: #time of: self;
		script: (html jQuery new timepickr
			trigger: 'focus';
			animSpeed: 'slow';
			resetOnBlur: true;
			rangeEvery5Min;
			select: ((html jQuery ajax serializeThis), 
				((html jQuery id: #timevalue) load html: [ :r | self renderTimeOn: r ]) ));
		with: time asString
! !

!JQTimepickrExample methodsFor: 'accessing' stamp: 'JohnMcKeon 8/29/2010 13:44'!
time
	"Answer the value of time"

	^ time! !

!JQTimepickrExample methodsFor: 'accessing' stamp: 'JohnMcKeon 8/29/2010 13:44'!
time: anObject
	"Set the value of time"

	time := anObject! !

!JQTimepickrExample methodsFor: 'rendering' stamp: 'JohnMcKeon 8/30/2010 18:01'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	JQBaseTheme default updateRoot: anHtmlRoot.
	anHtmlRoot javascript url: self library / #timepickrJs.
	anHtmlRoot stylesheet url: self library / #jquerytimepickrCss.
	! !

!JQTimepickrExample methodsFor: 'accessing' stamp: 'JohnMcKeon 8/29/2010 16:31'!
url
	^'http://bililite.com/blog/2009/07/09/updating-timepickr/'! !

JQWidgetBoxWidgetTest subclass: #JQTimepickrTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-TimePickr-Dev-Tests'!

!JQTimepickrTest methodsFor: 'testing' stamp: 'JohnMcKeon 8/29/2010 16:59'!
testAnimSpeed
	self
		assert: ((self jQuery: 'input') timepickr animSpeed: 'slow')
		equals: self function , '("input").timepickr({"animSpeed":"slow"})'.
! !

!JQTimepickrTest methodsFor: 'testing' stamp: 'JohnMcKeon 8/29/2010 17:02'!
testConvention
	self
		assert: ((self jQuery: 'input') timepickr convention: 12)
		equals: self function , '("input").timepickr({"convention":12})'.
! !

!JQTimepickrTest methodsFor: 'testing' stamp: 'JohnMcKeon 8/30/2010 16:42'!
testHandle
	self
		assert: ((self jQuery: 'input') timepickr handle: true)
		equals: self function , '("input").timepickr({"handle":true})'.
	self
		assert: ((self jQuery: 'input') timepickr handle: 'test')
		equals: self function , '("input").timepickr({"handle":"test"})'.
	self
		assert: ((self jQuery: 'input') timepickr handle: '$("#clock")')
		equals: self function , '("input").timepickr({"handle":$("#clock")})'.
! !

!JQTimepickrTest methodsFor: 'testing' stamp: 'JohnMcKeon 8/30/2010 17:50'!
testHoverIntent
	self
		assert: ((self jQuery: 'input') timepickr hoverIntent: true)
		equals: self function , '("input").timepickr({"hoverIntent":true})'.
! !

!JQTimepickrTest methodsFor: 'testing' stamp: 'JohnMcKeon 8/29/2010 16:59'!
testMethod
	self
		assert: ((self jQuery: 'input') timepickr)
		equals: self function , '("input").timepickr()'.
! !

!JQTimepickrTest methodsFor: 'testing' stamp: 'JohnMcKeon 8/30/2010 17:57'!
testOther
	self
		assert: ((self jQuery: 'input') timepickr format: '{h}:{m} {suffix}')
		equals: self function , '("input").timepickr({"format":"{h}:{m} {suffix}"})'.
	self
		assert: ((self jQuery: 'input') timepickr top: 100)
		equals: self function , '("input").timepickr({"top":"100"})'.
	self
		assert: ((self jQuery: 'input') timepickr left: 100)
		equals: self function , '("input").timepickr({"left":"100"})'.
	
! !

!JQTimepickrTest methodsFor: 'testing' stamp: 'JohnMcKeon 8/30/2010 17:24'!
testPrefix
	self
		assert: ((self jQuery: 'input') timepickr prefix: #('1' '2' '3' '4' '5'))
		equals: self function , '("input").timepickr({"prefix":["1","2","3","4","5"]})'.
! !

!JQTimepickrTest methodsFor: 'testing' stamp: 'JohnMcKeon 8/29/2010 16:59'!
testRangeMin
	self
		assert: ((self jQuery: 'input') timepickr rangeMin: #('1' '2' '3' '4' '5'))
		equals: self function , '("input").timepickr({"rangeMin":["1","2","3","4","5"]})'.
	self
		assert: ((self jQuery: 'input') timepickr rangeEvery5Min)
		equals: self function , '("input").timepickr({"rangeMin":["00","05","10","15","20","25","30","35","40","45","50","55"]})'.
	self
		assert: ((self jQuery: 'input') timepickr rangeEvery15Min)
		equals: self function , '("input").timepickr({"rangeMin":["00","15","30","45"]})'.
		


! !

!JQTimepickrTest methodsFor: 'testing' stamp: 'JohnMcKeon 8/30/2010 17:44'!
testSelect
	self
		assert: ((self jQuery: 'input') timepickr select: 'aCallback')
		equals: self function , '("input").timepickr({"select":function(){aCallback}})'.
! !

!JQTimepickrTest methodsFor: 'testing' stamp: 'JohnMcKeon 8/30/2010 17:31'!
testSuffix
	self
		assert: ((self jQuery: 'input') timepickr suffix: #('1' '2' '3' '4' '5'))
		equals: self function , '("input").timepickr({"suffix":["1","2","3","4","5"]})'.
! !

!JQTimepickrTest methodsFor: 'testing' stamp: 'tbn 9/22/2010 13:20'!
testVal
	self
		assert: ((self jQuery: 'input') timepickr val: '05:00 pm')
		equals: self function , '("input").timepickr({"val":"05:00 pm"})'.
! !
